package io.github.rmuhamedgaliev.service.RAM;

/**
 * Developer: Muhamedgaliev Rinat
 */
public interface RAMInformation
{
    /**
     * Return total RAM size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value RAM
     */
    Long getTotalRAM(String measure);
    /**
     * Return free RAM size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value RAM
     */
    Long getFreeRAM(String measure);
    /**
     * Return used RAM size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value RAM
     */
    Long getUsedRAM(String measure);
    /**
     * Return free SWAP size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value SWAP
     */
    Long getFreeSwap(String measure);
    /**
     * Return total SWAP size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value SWAP
     */
    Long getTotalSwap(String measure);
    /**
     * Return used SWAP size by defined measured. Use follow signatures:
     * GiB - in gigabyte
     * MiB - in megabyte
     * KiB - in kilobyte
     * @param measure
     * @return value SWAP
     */
    Long getUsedSwap(String measure);
}
